
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Map.Entry;


public class Timing
{
	private long fStart = 0;
	private Map<String, Long> fTimings = new HashMap<String, Long>();
	private int fMaxNameLength = 0;
	private int fMaxTimingLength = 0;


	public Timing start()
	{
		fStart = System.nanoTime();
		return this;
	}


	public void stop(String name)
	{
		long time = System.nanoTime();
		Long timing = fTimings.get(name);
		timing = (timing == null ? 0L : timing) + time - fStart;
		fTimings.put(name, timing);
		fStart = time;
	}


	public String get(String name, int dividend)
	{
		if (fMaxNameLength == 0 && fMaxTimingLength == 0)
		{
			for (Entry<String, Long> entry : fTimings.entrySet())
			{
				int nameLength = entry.getKey().length();
				if (nameLength > fMaxNameLength)
				{
					fMaxNameLength = nameLength;
				}
				int timingLength = String.format(Locale.getDefault(), "%,d", entry.getValue() / dividend)
							.length();
				if (timingLength > fMaxTimingLength)
				{
					fMaxTimingLength = timingLength;
				}
			}
			fMaxNameLength++;
		}
		return String.format(Locale.getDefault(), "  %-" + fMaxNameLength + "s %," + fMaxTimingLength
					+ "d nanoseconds", name + ":", fTimings.get(name) / dividend);
	}
}
